<!-- Observer.vue -->
<template>
  <div class="observer">
      <div class="loader">
        <div class="one"></div>
        <div class="two"></div>
        <div class="three"></div>
      </div>
  </div>
</template>

<script>
export default {
  props: ['options'],
  data: () => ({
    observer: null
  }),
  mounted () {
    const options = this.options || {}
    this.observer = new IntersectionObserver(([entry]) => {
      if (entry && entry.isIntersecting) {
        this.$emit('intersect')
      }
    }, options)

    this.observer.observe(this.$el)
  },
  destroyed () {
    this.observer.disconnect()
  }
}
</script>

<style lang="scss">

@-webkit-keyframes bouncedelay {
    0%, 80%, 100% {
        -webkit-transform: scale(0)
    }

    40% {
        -webkit-transform: scale(1)
    }
}

@keyframes bouncedelay {
    0%, 80%, 100% {
        -webkit-transform: scale(0);
        transform: scale(0)
    }

    40% {
        transform: scale(1);
        -webkit-transform: scale(1)
    }
}

.loader {
    height: 29px;
    z-index: 10;
    display: inline-block;
    text-align: center;
    font-size: 26px;
    width: 90px;
    margin: 30px;

    > div {
        display: inline-block;
        width: 14px;
        height: 14px;
        border-radius: 100%;
        background-color: transparent;
        border: 1px solid #fff;
        -webkit-animation: bouncedelay 1.4s infinite ease-in-out both;
        animation: bouncedelay 1.4s infinite ease-in-out both;
        margin: 0 7px;
    }
    .one {
        -webkit-animation-delay: -0.32s;
        animation-delay: -0.32s;
    }
    .two {
        -webkit-animation-delay: -0.16s;
        animation-delay: -0.16s;
    }
}
</style>
